local _G = getfenv(0)
local db
local name, localizedname = GetAddOnInfo("YurrCombatLog")
local core = DongleStub("Dongle-1.2"):New(name)
_G.YurrCombatLog = core
local L = _G.YurrCombatLogLocale
if tekDebug then core:EnableDebug(1, tekDebug:GetFrame("YurrCombatLog-Log")) end
local CombatLogQuickButtonFrameProgressBar
--local CombatLogUpdateFrame = CreateFrame("Frame", "CombatLogUpdateFrame", UIParent)

function core:showoptionsgui()
	if not IsAddOnLoaded("YurrCombatLogOptions") then
		local _, reason = LoadAddOn("YurrCombatLogOptions")
		local _, title = GetAddOnInfo("YurrCombatLogOptions")
		if (not title) then title = "YurrCombatLogOptions" end
		if reason then
			core:Print( title .. " (Enable) LoadOnDemand Error - " .. reason )
		end
    end
	InterfaceOptionsFrame_OpenToCategory("YurrCombatLog")
end

local ldb = LibStub("LibDataBroker-1.1")
local dataobj = ldb:NewDataObject("YurrCombatLogOptions", {icon = "Interface\\Icons\\Ability_MeleeDamage", text = "YurrCombatLog"})

function dataobj.OnTooltipShow(self)
	self:AddLine(dataobj.text)
	self:AddLine("|cffffff00"..L.leftClick)
end

dataobj.OnClick = function() core:showoptionsgui() end

--[[
[SCHOOL_MASK_PHYSICAL]						= STRING_SCHOOL_PHYSICAL,
[SCHOOL_MASK_HOLY]							= STRING_SCHOOL_HOLY,
[SCHOOL_MASK_FIRE]							= STRING_SCHOOL_FIRE,
[SCHOOL_MASK_NATURE]						= STRING_SCHOOL_NATURE,
[SCHOOL_MASK_FROST]							= STRING_SCHOOL_FROST,
[SCHOOL_MASK_SHADOW]						= STRING_SCHOOL_SHADOW,
[SCHOOL_MASK_ARCANE]						= STRING_SCHOOL_ARCANE,
-- Physical and a Magical
[SCHOOL_MASK_PHYSICAL + SCHOOL_MASK_FIRE]	= STRING_SCHOOL_FLAMESTRIKE,
[SCHOOL_MASK_PHYSICAL + SCHOOL_MASK_FROST]	= STRING_SCHOOL_FROSTSTRIKE,
[SCHOOL_MASK_PHYSICAL + SCHOOL_MASK_ARCANE]	= STRING_SCHOOL_SPELLSTRIKE,
[SCHOOL_MASK_PHYSICAL + SCHOOL_MASK_NATURE]	= STRING_SCHOOL_STORMSTRIKE,
[SCHOOL_MASK_PHYSICAL + SCHOOL_MASK_SHADOW]	= STRING_SCHOOL_SHADOWSTRIKE,
[SCHOOL_MASK_PHYSICAL + SCHOOL_MASK_HOLY]	= STRING_SCHOOL_HOLYSTRIKE,
-- Two Magical Schools
[SCHOOL_MASK_FIRE + SCHOOL_MASK_FROST]		= STRING_SCHOOL_FROSTFIRE,
[SCHOOL_MASK_FIRE + SCHOOL_MASK_ARCANE]		= STRING_SCHOOL_SPELLFIRE,
[SCHOOL_MASK_FIRE + SCHOOL_MASK_NATURE]		= STRING_SCHOOL_FIRESTORM,
[SCHOOL_MASK_FIRE + SCHOOL_MASK_SHADOW]		= STRING_SCHOOL_SHADOWFLAME,
[SCHOOL_MASK_FIRE + SCHOOL_MASK_HOLY]		= STRING_SCHOOL_HOLYFIRE,
[SCHOOL_MASK_FROST + SCHOOL_MASK_ARCANE]	= STRING_SCHOOL_SPELLFROST,
[SCHOOL_MASK_FROST + SCHOOL_MASK_NATURE]	= STRING_SCHOOL_FROSTSTORM,
[SCHOOL_MASK_FROST + SCHOOL_MASK_SHADOW]	= STRING_SCHOOL_SHADOWFROST,
[SCHOOL_MASK_FROST + SCHOOL_MASK_HOLY]		= STRING_SCHOOL_HOLYFROST,
[SCHOOL_MASK_ARCANE + SCHOOL_MASK_NATURE]	= STRING_SCHOOL_SPELLSTORM,
[SCHOOL_MASK_ARCANE + SCHOOL_MASK_SHADOW]	= STRING_SCHOOL_SPELLSHADOW,
[SCHOOL_MASK_ARCANE + SCHOOL_MASK_HOLY]		= STRING_SCHOOL_DIVINE,
[SCHOOL_MASK_NATURE + SCHOOL_MASK_SHADOW]	= STRING_SCHOOL_SHADOWSTORM,
[SCHOOL_MASK_NATURE + SCHOOL_MASK_HOLY]		= STRING_SCHOOL_HOLYSTORM,
[SCHOOL_MASK_SHADOW + SCHOOL_MASK_HOLY]		= STRING_SCHOOL_SHADOWLIGHT,
-- Three or more schools
[SCHOOL_MASK_FIRE + SCHOOL_MASK_FROST + SCHOOL_MASK_NATURE]																						= STRING_SCHOOL_ELEMENTAL,
[SCHOOL_MASK_FIRE + SCHOOL_MASK_FROST + SCHOOL_MASK_ARCANE + SCHOOL_MASK_NATURE + SCHOOL_MASK_SHADOW]											= STRING_SCHOOL_CHROMATIC,
[SCHOOL_MASK_FIRE + SCHOOL_MASK_FROST + SCHOOL_MASK_ARCANE + SCHOOL_MASK_NATURE + SCHOOL_MASK_SHADOW + SCHOOL_MASK_HOLY]						= STRING_SCHOOL_MAGIC,
[SCHOOL_MASK_PHYSICAL + SCHOOL_MASK_FIRE + SCHOOL_MASK_FROST + SCHOOL_MASK_ARCANE + SCHOOL_MASK_NATURE + SCHOOL_MASK_SHADOW + SCHOOL_MASK_HOLY]	= STRING_SCHOOL_CHAOS,]]

local schools = {
	[1] = SPELL_SCHOOL0_NAME, -- physical
	[2] = SPELL_SCHOOL1_NAME, -- holy
	[4] = SPELL_SCHOOL2_NAME, -- fire
	[8] = SPELL_SCHOOL3_NAME, -- nature
	[16] = SPELL_SCHOOL4_NAME, -- frost
	[20] = SPELL_SCHOOL4_NAME..SPELL_SCHOOL2_NAME, -- frostfire(frost + fire)
	[24] = SPELL_SCHOOL4_NAME..SPELL_SCHOOL3_NAME, -- froststorm(frost + nature)
	[32] = SPELL_SCHOOL5_NAME, -- shadow
	[40] = SPELL_SCHOOL3_NAME..SPELL_SCHOOL5_NAME, -- shadowstorm(shadow + nature)
	[64] = SPELL_SCHOOL6_NAME, -- arcane
	[66] = SPELL_SCHOOL6_NAME..SPELL_SCHOOL1_NAME, -- divine(arcane + holy)
	[80] = SPELL_SCHOOL4_NAME..SPELL_SCHOOL6_NAME -- spellfrost(frost + arcane)
}
local powerTypes = {
	[-2] = string.lower(HEALTH),
	[0] = string.lower(MANA),
	[1] = string.lower(RAGE),
	[2] = string.lower(FOCUS),
	[3] = string.lower(ENERGY),
	[4] = string.lower(PET .. HAPPINESS),
	[5] = string.lower(RUNES),
	[6] = string.lower(RUNIC_POWER),
}

function core:Initialize()
	local cmd = self:InitializeSlashCommand("YurrCombatLog slash commands", "yurrcombatlog", "ycl")
	cmd:RegisterSlashHandler("Open the options menu", "^$", "showoptionsgui")
		
	if YurrCombatLogDB then if YurrCombatLogDB.namespaces then YurrCombatLogDB = {} end end
    self.db = self:InitializeDB("YurrCombatLogDB", {
		global = {
			outputFrame = "ChatFrame3",
			unitColors = {
				[1297] = "8080FF", -- self
				[4991] = "804D26", -- pet
				[1394] = "A6FFA6", -- party
				[1396] = "FF7038", -- raid
				[9087] = "404080", -- guardian
				[131072] = "CC54D9", -- focus
				[20334] = "FF75FF", -- enemy players/npcs
				[3864] = "FFFFFF", -- outsider
			},
			spellColors = {
				[1] = "FFFFFF", -- physical
				[2] = "FFFF4D", -- holy
				[4] = "FF262E", -- fire
				[8] = "66FF66", -- nature
				[16] = "4D4DE6", -- frost
				[20] = "A63B96", -- frostfire(frost + fire)
				[24] = "5AA6A6", -- froststorm(frost + nature)
				[32] = "FFB3FF", -- shadow
				[40] = "B3D9B3", -- shadowstorm(shadow + nature)
				[64] = "BFBFBF", -- arcane
				[66] = "E9E986", -- divine(arcane + holy)
				[80] = "8686D3" -- spellfrost(frost + arcane)
			},
			otherColors = {
				heal = "FFFF4D",
				miss = "FF8080", -- unused for the moment
				buff = "33FF33",
				debuff = "FF3333",
				skill = "FFFF66",
				timestampColor = "737373",
			},
			braceSrcUnit = true,
			leftSrcBrace = "[",
			rightSrcBrace = "]",
			colorSrc = true,
			colorSrcBraces = false,
			leftSrcBraceColor = "FF75FF",
			rightSrcBraceColor = "FF75FF",
			
			prefix = true,
			colorPrefix = true,
			["++"] = "++",
			["--"] = "--",
			["~~"] = "~~",
			
			braceSpell = false,
			leftSpellBrace = "[",
			rightSpellBrace = "]",
			colorSpell = true,
			colorSpellBraces = false,
			leftSpellBraceColor = "FF75FF",
			rightSpellBraceColor = "FF75FF",
			
			spellSchools = false,
			swingSchools = false,
			rangedSchools = false,
			
			suffixString = true,
			resultInSuffix = true,
			
			braceDestUnit = true,
			leftDestBrace = "[",
			rightDestBrace = "]",
			colorDest = true,
			colorDestBraces = false,
			leftDestBraceColor = "FF75FF",
			rightDestBraceColor = "FF75FF",
			
			braceAmount = true,
			leftAmountBrace = "[",
			rightAmountBrace = "]",
			colorAmount = true,
			colorAmountBraces = false,
			leftAmountBraceColor = "FF75FF",
			rightAmountBraceColor = "FF75FF",
			braceAmountDots = true,
			leftAmountDotsBrace = "~",
			rightAmountDotsBrace = "~",
			colorAmountDotBraces = false,
			leftAmountDotBraceColor = "FF75FF",
			rightAmountDotBraceColor = "FF75FF",
			markCrits = true,
			leftCrit = "*",
			rightCrit = "*",
			
			overhealing = true,
			overkill = true,
			
			resultString = true,
			
			powerType = true,
			
			schoolText = false,
			colorSchoolText = true,
			braceSchoolText = false,
			colorSchoolTextBraces = false,
			schoolTextBraceLeft = "[",
			schoolTextBraceRight = "]",
			
			format = {
				ABSORB = "(A%d)",
				BLOCK = BLOCK,
				BLOCK_VALUE = "(B%d)",
				CRITICAL = L["Crit"],
				CRUSHING = L["Crush"],
				DEFLECT = DEFLECT,
				DODGE = DODGE,
				EVADE = L["Evade"],
				GLANCING = L["Glancing"],
				IMMUNE = SPELL_FAILED_IMMUNE,
				MISS = MISS,
				PARRY = PARRY,
				REFLECT = REFLECT,
				RESIST = "(R%d)",
				VULNERABILITY = "(V%d)",
			},
			filters = {
				[1] = {
					name = "Self",
					active = true,
					ENVIRONMENTAL_DAMAGE = true,
					SWING_DAMAGE = true,
					SWING_MISSED = true,
					RANGE_DAMAGE = true,
					RANGE_MISSED = true,
					SPELL_CAST_START = false,
					SPELL_CAST_SUCCESS = false,
					SPELL_CAST_FAILED = false,
					SPELL_MISSED = true,
					SPELL_DAMAGE = true,
					SPELL_HEAL = true,
					SPELL_ENERGIZE = true,
					SPELL_DRAIN = true,
					SPELL_LEECH = true,
					SPELL_SUMMON = true,
					SPELL_RESURRECT = true,
					SPELL_CREATE = true,
					SPELL_INSTAKILL = true,
					SPELL_INTERRUPT = true,
					SPELL_EXTRA_ATTACKS = true,
					SPELL_DURABILITY_DAMAGE = false,
					SPELL_DURABILITY_DAMAGE_ALL = false,
					SPELL_AURA_APPLIED = true,
					SPELL_AURA_APPLIED_DOSE = true,
					SPELL_AURA_REMOVED = true,
					SPELL_AURA_REMOVED_DOSE = true,
					SPELL_AURA_BROKEN = true,
					SPELL_AURA_BROKEN_SPELL = true,
					SPELL_AURA_REFRESH = true,
					SPELL_DISPEL = true,
					SPELL_STOLEN = true,
					ENCHANT_APPLIED = true,
					ENCHANT_REMOVED = true,
					SPELL_PERIODIC_MISSED = true,
					SPELL_PERIODIC_DAMAGE = true,
					SPELL_PERIODIC_HEAL = true,
					SPELL_PERIODIC_ENERGIZE = true,
					SPELL_PERIODIC_DRAIN = true,
					SPELL_PERIODIC_LEECH = true,
					SPELL_DISPEL_FAILED = true,
					DAMAGE_SHIELD = true,
					DAMAGE_SHIELD_MISSED = true,
					DAMAGE_SPLIT = true,
					PARTY_KILL = true,
					UNIT_DIED = true,
					UNIT_DESTROYED = true,
					SPELL_BUILDING_DAMAGE = true,
					SPELL_BUILDING_HEAL = true,
					sourceUnit = {
						--Controller affiliation
						COMBATLOG_OBJECT_AFFILIATION_MINE = true,
						COMBATLOG_OBJECT_AFFILIATION_PARTY = false,
						COMBATLOG_OBJECT_AFFILIATION_RAID = false,
						COMBATLOG_OBJECT_AFFILIATION_OUTSIDER = false,
						--Reaction
						COMBATLOG_OBJECT_REACTION_FRIENDLY = true,
						COMBATLOG_OBJECT_REACTION_NEUTRAL = false,
						COMBATLOG_OBJECT_REACTION_HOSTILE = false,
						--Controller
						COMBATLOG_OBJECT_CONTROL_PLAYER = true,
						COMBATLOG_OBJECT_CONTROL_NPC = false,
						--Type
						COMBATLOG_OBJECT_TYPE_PLAYER = true,
						COMBATLOG_OBJECT_TYPE_NPC = false,
						COMBATLOG_OBJECT_TYPE_PET = false,
						COMBATLOG_OBJECT_TYPE_GUARDIAN = false,
						COMBATLOG_OBJECT_TYPE_OBJECT = false,
						--Special cases (non-exclusive)
						COMBATLOG_OBJECT_TARGET = false,
						COMBATLOG_OBJECT_FOCUS = false,
						COMBATLOG_OBJECT_MAINTANK = false,
						COMBATLOG_OBJECT_MAINASSIST = false,
						COMBATLOG_OBJECT_RAIDTARGET1 = false,
						COMBATLOG_OBJECT_RAIDTARGET2 = false,
						COMBATLOG_OBJECT_RAIDTARGET3 = false,
						COMBATLOG_OBJECT_RAIDTARGET4 = false,
						COMBATLOG_OBJECT_RAIDTARGET5 = false,
						COMBATLOG_OBJECT_RAIDTARGET6 = false,
						COMBATLOG_OBJECT_RAIDTARGET7 = false,
						COMBATLOG_OBJECT_RAIDTARGET8 = false,
						COMBATLOG_OBJECT_NONE = false,
					},
					destUnit = {
						--Controller affiliation
						COMBATLOG_OBJECT_AFFILIATION_MINE = false,
						COMBATLOG_OBJECT_AFFILIATION_PARTY = false,
						COMBATLOG_OBJECT_AFFILIATION_RAID = false,
						COMBATLOG_OBJECT_AFFILIATION_OUTSIDER = false,
						--Reaction
						COMBATLOG_OBJECT_REACTION_FRIENDLY = false,
						COMBATLOG_OBJECT_REACTION_NEUTRAL = false,
						COMBATLOG_OBJECT_REACTION_HOSTILE = false,
						--Controller
						COMBATLOG_OBJECT_CONTROL_PLAYER = false,
						COMBATLOG_OBJECT_CONTROL_NPC = false,
						--Type
						COMBATLOG_OBJECT_TYPE_PLAYER = false,
						COMBATLOG_OBJECT_TYPE_NPC = false,
						COMBATLOG_OBJECT_TYPE_PET = false,
						COMBATLOG_OBJECT_TYPE_GUARDIAN = false,
						COMBATLOG_OBJECT_TYPE_OBJECT = false,
						--Special cases (non-exclusive)
						COMBATLOG_OBJECT_TARGET = false,
						COMBATLOG_OBJECT_FOCUS = false,
						COMBATLOG_OBJECT_MAINTANK = false,
						COMBATLOG_OBJECT_MAINASSIST = false,
						COMBATLOG_OBJECT_RAIDTARGET1 = false,
						COMBATLOG_OBJECT_RAIDTARGET2 = false,
						COMBATLOG_OBJECT_RAIDTARGET3 = false,
						COMBATLOG_OBJECT_RAIDTARGET4 = false,
						COMBATLOG_OBJECT_RAIDTARGET5 = false,
						COMBATLOG_OBJECT_RAIDTARGET6 = false,
						COMBATLOG_OBJECT_RAIDTARGET7 = false,
						COMBATLOG_OBJECT_RAIDTARGET8 = false,
						COMBATLOG_OBJECT_NONE = false,
					},
				},
				[2] = {
					name = "Everything",
					active = false,
					ENVIRONMENTAL_DAMAGE = true,
					SWING_DAMAGE = true,
					SWING_MISSED = true,
					RANGE_DAMAGE = true,
					RANGE_MISSED = true,
					SPELL_CAST_START = true,
					SPELL_CAST_SUCCESS = true,
					SPELL_CAST_FAILED = true,
					SPELL_MISSED = true,
					SPELL_DAMAGE = true,
					SPELL_HEAL = true,
					SPELL_ENERGIZE = true,
					SPELL_DRAIN = true,
					SPELL_LEECH = true,
					SPELL_SUMMON = true,
					SPELL_RESURRECT = true,
					SPELL_CREATE = true,
					SPELL_INSTAKILL = true,
					SPELL_INTERRUPT = true,
					SPELL_EXTRA_ATTACKS = true,
					SPELL_DURABILITY_DAMAGE = true,
					SPELL_DURABILITY_DAMAGE_ALL = true,
					SPELL_AURA_APPLIED = true,
					SPELL_AURA_APPLIED_DOSE = true,
					SPELL_AURA_REMOVED = true,
					SPELL_AURA_REMOVED_DOSE = true,
					SPELL_AURA_BROKEN = true,
					SPELL_AURA_BROKEN_SPELL = true,
					SPELL_AURA_REFRESH = true,
					SPELL_DISPEL = true,
					SPELL_STOLEN = true,
					ENCHANT_APPLIED = true,
					ENCHANT_REMOVED = true,
					SPELL_PERIODIC_MISSED = true,
					SPELL_PERIODIC_DAMAGE = true,
					SPELL_PERIODIC_HEAL = true,
					SPELL_PERIODIC_ENERGIZE = true,
					SPELL_PERIODIC_DRAIN = true,
					SPELL_PERIODIC_LEECH = true,
					SPELL_DISPEL_FAILED = true,
					DAMAGE_SHIELD = true,
					DAMAGE_SHIELD_MISSED = true,
					DAMAGE_SPLIT = true,
					PARTY_KILL = true,
					UNIT_DIED = true,
					UNIT_DESTROYED = true,
					SPELL_BUILDING_DAMAGE = true,
					SPELL_BUILDING_HEAL = true,
					sourceUnit = {
						--Controller affiliation
						COMBATLOG_OBJECT_AFFILIATION_MINE = true,
						COMBATLOG_OBJECT_AFFILIATION_PARTY = true,
						COMBATLOG_OBJECT_AFFILIATION_RAID = true,
						COMBATLOG_OBJECT_AFFILIATION_OUTSIDER = true,
						--Reaction
						COMBATLOG_OBJECT_REACTION_FRIENDLY = true,
						COMBATLOG_OBJECT_REACTION_NEUTRAL = true,
						COMBATLOG_OBJECT_REACTION_HOSTILE = true,
						--Controller
						COMBATLOG_OBJECT_CONTROL_PLAYER = true,
						COMBATLOG_OBJECT_CONTROL_NPC = true,
						--Type
						COMBATLOG_OBJECT_TYPE_PLAYER = true,
						COMBATLOG_OBJECT_TYPE_NPC = true,
						COMBATLOG_OBJECT_TYPE_PET = true,
						COMBATLOG_OBJECT_TYPE_GUARDIAN = true,
						COMBATLOG_OBJECT_TYPE_OBJECT = true,
						--Special cases (non-exclusive)
						COMBATLOG_OBJECT_TARGET = true,
						COMBATLOG_OBJECT_FOCUS = true,
						COMBATLOG_OBJECT_MAINTANK = true,
						COMBATLOG_OBJECT_MAINASSIST = true,
						COMBATLOG_OBJECT_RAIDTARGET1 = true,
						COMBATLOG_OBJECT_RAIDTARGET2 = true,
						COMBATLOG_OBJECT_RAIDTARGET3 = true,
						COMBATLOG_OBJECT_RAIDTARGET4 = true,
						COMBATLOG_OBJECT_RAIDTARGET5 = true,
						COMBATLOG_OBJECT_RAIDTARGET6 = true,
						COMBATLOG_OBJECT_RAIDTARGET7 = true,
						COMBATLOG_OBJECT_RAIDTARGET8 = true,
						COMBATLOG_OBJECT_NONE = true,
					},
					destUnit = {
						--Controller affiliation
						COMBATLOG_OBJECT_AFFILIATION_MINE = true,
						COMBATLOG_OBJECT_AFFILIATION_PARTY = true,
						COMBATLOG_OBJECT_AFFILIATION_RAID = true,
						COMBATLOG_OBJECT_AFFILIATION_OUTSIDER = true,
						--Reaction
						COMBATLOG_OBJECT_REACTION_FRIENDLY = true,
						COMBATLOG_OBJECT_REACTION_NEUTRAL = true,
						COMBATLOG_OBJECT_REACTION_HOSTILE = true,
						--Controller
						COMBATLOG_OBJECT_CONTROL_PLAYER = true,
						COMBATLOG_OBJECT_CONTROL_NPC = true,
						--Type
						COMBATLOG_OBJECT_TYPE_PLAYER = true,
						COMBATLOG_OBJECT_TYPE_NPC = true,
						COMBATLOG_OBJECT_TYPE_PET = true,
						COMBATLOG_OBJECT_TYPE_GUARDIAN = true,
						COMBATLOG_OBJECT_TYPE_OBJECT = true,
						--Special cases (non-exclusive)
						COMBATLOG_OBJECT_TARGET = true,
						COMBATLOG_OBJECT_FOCUS = true,
						COMBATLOG_OBJECT_MAINTANK = true,
						COMBATLOG_OBJECT_MAINASSIST = true,
						COMBATLOG_OBJECT_RAIDTARGET1 = true,
						COMBATLOG_OBJECT_RAIDTARGET2 = true,
						COMBATLOG_OBJECT_RAIDTARGET3 = true,
						COMBATLOG_OBJECT_RAIDTARGET4 = true,
						COMBATLOG_OBJECT_RAIDTARGET5 = true,
						COMBATLOG_OBJECT_RAIDTARGET6 = true,
						COMBATLOG_OBJECT_RAIDTARGET7 = true,
						COMBATLOG_OBJECT_RAIDTARGET8 = true,
						COMBATLOG_OBJECT_NONE = true,
					},
				},
			},
		},
	}, "global")
    db = self.db[self.db:GetCurrentProfile()]
end

local oldBlizzard_CombatLog_Refilter
local oldBlizzard_CombatLog_RefilterUpdate
local oldCombatLog_AddEvent
local function fakeFunc() end

function core:Enable()
	oldBlizzard_CombatLog_Refilter = Blizzard_CombatLog_Refilter
	oldBlizzard_CombatLog_RefilterUpdate = Blizzard_CombatLog_RefilterUpdate
	
	core:RegisterEvent("COMBAT_LOG_EVENT")
	
	function Blizzard_CombatLog_Refilter()
		local count = CombatLogGetNumEntries();
		
		COMBATLOG:SetMaxLines(COMBATLOG_MESSAGE_LIMIT);
		_G[db.outputFrame]:SetMaxLines(COMBATLOG_MESSAGE_LIMIT)

		-- count should be between 1 and COMBATLOG_MESSAGE_LIMIT
		count = max(1, min(count, COMBATLOG_MESSAGE_LIMIT));

		CombatLogSetCurrentEntry(0);
		
		-- Clear the combat log
		--COMBATLOG:Clear();
		_G[db.outputFrame]:Clear()
		
		-- Moved setting the max value here, since we don't really need to reset the max every frame, do we?
		-- We can't add events while refiltering (:AddFilter short circuits) so this should be safe optimization.
		CombatLogQuickButtonFrameProgressBar:SetMinMaxValues(0, count);	
		CombatLogQuickButtonFrameProgressBar:SetValue(0);
		CombatLogQuickButtonFrameProgressBar:Show();

		-- Enable the distributed frame
		CombatLogUpdateFrame.refiltering = true;
		CombatLogUpdateFrame:SetScript("OnUpdate", Blizzard_CombatLog_RefilterUpdate)	
		
		Blizzard_CombatLog_RefilterUpdate()
	end
	
	CombatLogQuickButtonFrameProgressBar = _G.CombatLogQuickButtonFrame_CustomProgressBar
	Blizzard_CombatLog_RefilterUpdate = function()
		local valid = CombatLogGetCurrentEntry(); -- CombatLogAdvanceEntry(0);
		
		-- Clear the combat log
		local total = 0;
		while (valid and total < COMBATLOG_LIMIT_PER_FRAME) do 
			-- Log to the window
			--local text, r, g, b, a = CombatLog_OnEvent(Blizzard_CombatLog_CurrentSettings, CombatLogGetCurrentEntry());
			local YCLtext = self:processEvent("COMBAT_LOG_EVENT", CombatLogGetCurrentEntry())
			-- NOTE: be sure to pass in nil for the color id or the color id may override the r, g, b values for this message
			--COMBATLOG:AddMessage( text, r, g, b, nil, true );
			_G[db.outputFrame]:AddMessage( YCLtext, 1, 1, 1, nil, true );
			
			-- count can be 
			--  positive to advance from oldest to newest
			--  negative to advance from newest to oldest
			valid = CombatLogAdvanceEntry(-1)
			total = total + 1;
		end
		
		-- Show filtering progress bar
		CombatLogQuickButtonFrameProgressBar:SetValue(CombatLogQuickButtonFrameProgressBar:GetValue() + total);
		
		if ( not valid or (CombatLogQuickButtonFrameProgressBar:GetValue() >= COMBATLOG_MESSAGE_LIMIT) ) then
			CombatLogUpdateFrame.refiltering = false
			CombatLogUpdateFrame:SetScript("OnUpdate", nil)
			CombatLogQuickButtonFrameProgressBar:Hide();
		end
	end
	CombatLog_AddEvent = fakeFunc
	
	local enabled, loadable = select(4, GetAddOnInfo("YurrCombatLogOptions"))
	if enabled and loadable then
		local hijack = CreateFrame("Frame", nil, InterfaceOptionsFrame)
		hijack:SetScript("OnShow", function()
			hijack:Hide()
			local _, reason = LoadAddOn("YurrCombatLogOptions")
			local _, title = GetAddOnInfo("YurrCombatLogOptions")
			if (not title) then title = 'YurrCombatLogOptions' end
			if reason then
				self:Print( title .. " (Enable) LoadOnDemand Error - " .. reason )
			end
		end)
	end
    _G.SlashCmdList["ycl"] = showoptionsgui
end

function core:AffiliationColor(flags)
	local color
	for mask in pairs( db.unitColors ) do
		if ( CombatLog_Object_IsA (flags, mask) )then
			color = db.unitColors[mask]
			break
		end
	end
	return color
end

function core:ColorSpellBySchool(school, aura, suffix)
	if suffix == "_DISPEL" then
		return db.spellColors[school]
	elseif suffix == "_AURA_REMOVED" or suffix == "_AURA_REMOVED_DOSE" or suffix == "_MISSED" then
		return db.otherColors.skill
	elseif aura == "BUFF" then
		return db.otherColors.buff
	elseif aura == "DEBUFF" then
		return db.otherColors.debuff
	elseif suffix == "_HEAL" or suffix == "_PERIODIC_HEAL" then
		return db.otherColors.heal
	else
		if school == nil then
			self:Debug(1, "nil SPELLSCHOOL: ON suffix: " .. tostring(suffix))
		elseif not db.spellColors[school] then
			self:Debug(1, "MISSING SPELLSCHOOL: " .. school .. " ON suffix: " .. suffix)
		else
			return db.spellColors[school]
		end
	end
end

function core:DamageResult(resisted, blocked, absorbed, critical, glancing, crushing)

	local resultStr
	
	if ( resisted or blocked or absorbed or critical or glancing or crushing ) then
		
		if ( resisted ) then
			if ( resisted < 0 ) then	--Its really a vulnerability
				resultStr = format(db.format.VULNERABILITY, -resisted);
			else
				resultStr = format(db.format.RESIST, resisted);
			end
		end
		if ( blocked ) then
			if ( resultStr ) then
				resultStr = resultStr.." "..format(db.format.BLOCK_VALUE, blocked);
			else
				resultStr = format(db.format.BLOCK_VALUE, blocked);
			end
		end
		if ( absorbed ) then
			if ( resultStr ) then
				resultStr = resultStr.." "..format(db.format.ABSORB, absorbed);
			else
				resultStr = format(db.format.ABSORB, absorbed);
			end
		end
		if ( glancing ) then
			if ( resultStr ) then
				resultStr = resultStr.." "..db.format.GLANCING;
			else
				resultStr = db.format.GLANCING;
			end
		end
		if ( crushing ) then
			if ( resultStr ) then
				resultStr = resultStr.." "..db.format.CRUSHING;
			else
				resultStr = db.format.CRUSHING;
			end
		end
		if ( critical ) then
			local critString = db.format.CRITICAL;
			if ( spellId ) then
				critString = db.format.CRITICAL_SPELL;
			end
			if ( resultStr ) then
				resultStr = resultStr.." "..critString;
			else
				resultStr = critString;
			end
		end
	end
	
	return resultStr or ""

end

function core:COMBAT_LOG_EVENT(...)
	local t = self:processEvent(...)
	_G[db.outputFrame]:AddMessage(t)
end

function core:processEvent(...)
	--self:Debug(1, ...)
	
	local event = select(3, ...)
	
	local actionString
	
	local srcUnitName, srcFlags = select(5, ...)
	local srcUnitNameString
	
	local prefixString
	
	local spellName
	local spellNameString
	
	local suffixString
	
	local destUnitName, destFlags = select(8, ...)
	local destUnitNameString
	
	local amount
	local auraStack
	local overkill
	local overhealing
	local school
	local resisted
	local blocked
	local absorbed
	local critical
	local glancing
	local crushing
	local missType
	local amountMissed
	local powerType
	local extraSpellName
	local extraSchool
	local auraType
	local failedType
	local itemID
	local itemName
		
	local amountString
	local powerString
	local schoolStr
	local resultString
	
	local finalString
	
	if ( srcUnitName and CombatLog_Object_IsA(srcFlags, COMBATLOG_FILTER_MINE) ) then
			srcUnitName = UNIT_YOU_SOURCE;
	end
	if ( destUnitName and CombatLog_Object_IsA(destFlags, COMBATLOG_FILTER_MINE) ) then
			destUnitName = UNIT_YOU_DEST;
	end
	
	local base = 9
	local offset
	
	-- Prepare strings
	local prefix = strsub(event, 1, 5)
	local suffix = strsub(event, 6)
	
	-- Special events
	if event == "UNIT_DIED" then
		actionString = TUTORIAL_TITLE25 .. ": "
	elseif event == "UNIT_DESTROYED" then
		actionString = ACTION_UNIT_DESTROYED .. ": "
	elseif event == "ENCHANT_APPLIED" or event == "ENCHANT_REMOVED" then
		actionString = ENSCRIBE .. ": "
		offset = 0
		spellName, itemID, itemName = select(base + offset + 1, ...)
		school = 1
	elseif event == "PARTY_KILL" then
		spellName = ACTION_PARTY_KILL
		school = 1
	elseif event == "DAMAGE_SHIELD" or event == "DAMAGE_SPLIT" then
		offset = 3
		prefix = "SPELL"
		suffix = "_DAMAGE"
	elseif event == "DAMAGE_SHIELD_MISSED" then
		offset = 3
		prefix = "SPELL"
		suffix = "_MISSED"
	end
	
	if prefix == "SWING" then
		offset = 0
		spellName = MELEE
	elseif prefix == "SPELL" or prefix == "RANGE" then
		offset = 3
		spellName, school = select(11, ...)
	elseif prefix == "ENVIR" then
		offset = 1
		srcUnitName = destUnitName
		srcFlags = destFlags
		destUnitName = nil
		destFlags = nil
		local environmentalType = select(base + offset, ...)
		spellName = L[environmentalType]
		suffix = "_DAMAGE"
	end
	if suffix == "_DAMAGE" or suffix == "_PERIODIC_DAMAGE" or suffix == "_SPELL_BUILDING" then
		amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing = select(base + offset + 1, ...)
	elseif suffix == "_MISSED" or suffix == "_PERIODIC_MISSED" then
		missType, amountMissed = select(base + offset + 1, ...)
	elseif suffix == "_HEAL" or suffix == "_PERIODIC_HEAL" then
		amount, overhealing, critical = select(base + offset + 1, ...)
	elseif suffix == "_ENERGIZE" or suffix == "_PERIODIC_ENERGIZE" then
		amount, powerType = select(base + offset + 1, ...)
	elseif suffix == "_DRAIN" or suffix == "_LEECH" or suffix == "_PERIODIC_DRAIN" or suffix == "_PERIODIC_LEECH" then
		amount, powerType, extraAmount = select(base + offset + 1, ...)
	elseif suffix == "_INTERRUPT" or suffix == "_DISPEL" or suffix == "_DISPEL_FAILED" or suffix == "_STOLEN" or suffix == "_AURA_BROKEN_SPELL" then
		--extraSpellID = select(base + offset + 1, ...)
		extraSpellName, extraSchool, auraType = select(base + offset + 2, ...)
	elseif suffix == "_EXTRA_ATTACKS" then
		amount = select(base + offset + 1, ...)
		spellName =  format(L.extraAttack, amount, spellName)
		school = 1
	elseif suffix == "_AURA_APPLIED" or suffix == "_AURA_REMOVED" or suffix == "_AURA_APPLIED_DOSE" or suffix == "_AURA_REMOVED_DOSE" or suffix == "_AURA_REFRESH" or suffix == "_AURA_BROKEN" then
		auraType, auraStack = select(base + offset + 1, ...)
	elseif suffix == "_CAST_FAILED" then
		failedType = select(base + offset + 1, ...)
	end
	
	
	-- Process strings
	if srcUnitName then
		local str
		local coloredUnitStr
		local leftBrace
		local rightBrace
		if db.colorSrc then
			local color = self:AffiliationColor(srcFlags)
			coloredUnitStr = "|cFF" .. color .. srcUnitName .. "|r"
		end
		if db.colorSrcBraces then
			leftBrace = "|cFF" .. db.leftSrcBraceColor .. db.leftSrcBrace .. "|r"
			rightBrace = "|cFF" .. db.rightSrcBraceColor .. db.rightSrcBrace .. "|r"
		else
			leftBrace = db.leftSrcBrace
			rightBrace = db.rightSrcBrace
		end
		if db.braceSrcUnit then
			str = leftBrace .. "%s" .. rightBrace .. " "
		end
		srcUnitNameString = format(str or "%s ", coloredUnitStr or srcUnitName)
	else
		srcUnitNameString = ""
	end

	if db.prefix then
		local str
		if suffix == "_AURA_APPLIED" or suffix == "_AURA_APPLIED_DOSE" then
			str = db["++"]
		elseif suffix == "_AURA_REMOVED" or suffix == "_AURA_REMOVED_DOSE" then
			str = db["--"]
		elseif suffix == "_AURA_REFRESH" then
			str = db["~~"]
		elseif suffix == "_CAST_START" then
			str = L.begins
		elseif suffix == "_CAST_SUCCESS" then
			str = L.casts
		elseif suffix == "_CREATE" then
			str = L.create
		elseif suffix == "_INSTAKILL" then
			str = L.instantkill
		else
			str = ""
		end
		if db.colorPrefix and (str ~= "") then
			local color = self:ColorSpellBySchool(school, auraType, suffix)
			prefixString = format("|cFF%s%s|r ", color, str)
		elseif (str ~= "") then
			prefixString = str .. " "
		else
			prefixString = str
		end
	else
		prefixString = ""
	end
	
	if spellName then
		local coloredSpell
		local bracedSpell
		local leftBrace
		local rightBrace
		local stackedSpell
		if auraStack then stackedSpell = spellName .. "(" .. auraStack .. ")" else stackedSpell = spellName end
		
		if db.colorSpell then
			local color = self:ColorSpellBySchool(school, auraType, suffix)
			coloredSpell = "|cFF" .. color .. stackedSpell .. "|r"
		else
			coloredSpell = stackedSpell
		end
		if db.braceSpell then
			if db.colorSpellBraces then
				leftBrace = "|cFF" .. db.leftSpellBraceColor .. db.leftSpellBrace .. "|r"
				rightBrace = "|cFF" .. db.rightSpellBraceColor .. db.rightSpellBrace .. "|r"
			else
				leftBrace = db.leftSpellBrace
				rightBrace = db.rightSpellBrace
			end
			
			bracedSpell = (leftBrace) .. "%s" .. (rightBrace) .. " "
		else
			bracedSpell = "%s "
		end
		spellNameString = format(bracedSpell, coloredSpell)
	else
		spellNameString = ""
	end
	
	if db.suffixString then
		local str
		local result
		if suffix == "_HEAL" then
			str = L.Heal
		elseif suffix == "_PERIODIC_HEAL" then
			str = L.Regen
		elseif suffix == "_PERIODIC_DAMAGE" or suffix == "_PERIODIC_MISSED" then
			str = L.Dot
		elseif suffix == "_DISPEL" or suffix == "_DISPEL_FAILED" then
			str = L.Dispel
		elseif failedType then
			str = failedType
		end
		
		if missType == "MISS" then
			str = db.format.MISS
		end
		
		if str then
			suffixString = str .. " "
		else
			suffixString = ""
		end
	else
		suffixString = ""
	end
	
	if destUnitName then
		local str
		local coloredUnitStr
		local leftBrace
		local rightBrace
		if db.colorDest then
			local color = self:AffiliationColor(destFlags)
			coloredUnitStr = "|cFF" .. color .. destUnitName .. "|r"
		end
		if db.colorDestBraces then
			leftBrace = "|cFF" .. db.leftDestBraceColor .. db.leftDestBrace .. "|r"
			rightBrace = "|cFF" .. db.rightDestBraceColor .. db.rightDestBrace .. "|r"
		else
			leftBrace = db.leftDestBrace
			rightBrace = db.rightDestBrace
		end
		if db.braceDestUnit then
			str = leftBrace .. "%s" .. rightBrace .. " "
		end
		destUnitNameString = format(str or "%s ", coloredUnitStr or destUnitName)
	else
		destUnitNameString = ""
	end
	
	if amount then
		local str
		local amountResult
		local coloredAmountStr
		local leftBrace
		local rightBrace
		local leftDot
		local rightDot
		local leftCrit
		local rightCrit
		
		if db.overhealing and type(overhealing) == "number" and overhealing > 0 then
			amountResult = amount - overhealing .. "(+" .. overhealing .. ")"
		elseif db.overkill and type(overkill) == "number" and overkill > 0 then
			amountResult = amount - overkill .. "(+" .. overkill .. ")"
		else
			amountResult = amount
		end
		
		if suffix == "_ENERGIZE" or suffix == "_PERIODIC_ENERGIZE" then
			amountResult = "+ " .. amountResult
		end
		
		
		if db.colorAmount and school then
			local color = self:ColorSpellBySchool(school, auraType, suffix)
			coloredAmountStr = "|cFF" .. color .. amountResult .. "|r"
		end
		if db.braceAmount then
			if db.colorAmountBraces then
				leftBrace = "|cFF" .. db.leftAmountBraceColor .. db.leftAmountBrace .. "|r"
				rightBrace = "|cFF" .. db.rightAmountBraceColor .. db.rightAmountBrace .. "|r"
			else
				leftBrace = ""
				rightBrace = ""
			end
			str = "%s%s" .. leftBrace .. "%s" .. rightBrace .. "%s%s" .. " "
		end
		if db.braceAmountDots and suffix == "_PERIODIC_DAMAGE" or suffix == "_PERIODIC_HEAL" then
			if colorAmountDotBraces then
				leftDot = "|cFF" .. leftAmountDotBraceColor .. db.leftAmountDotsBrace .. rightAmountDotBraceColor .. "|r"
				leftDot = "|cFF" .. leftAmountDotBraceColor .. db.rightAmountDotsBrace .. rightAmountDotBraceColor .. "|r"
			else
				leftDot = db.leftAmountDotsBrace
				rightDot = db.rightAmountDotsBrace
			end
		else
			leftDot = ""
			rightDot = ""
		end
		if db.markCrits and critical then
			leftCrit = db.leftCrit
			rightCrit = db.rightCrit
		else
			leftCrit = ""
			rightCrit = ""
		end
		amountNameString = format(str or "%s%s%s%s%s ", leftCrit, leftDot, coloredAmountStr or amountResult, rightDot, rightCrit)
	else
		amountNameString = ""
	end
	if extraSpellName then
		local color = self:ColorSpellBySchool(extraSchool, auraType)
		amountNameString = "|cFF" .. color .. extraSpellName .. "|r "
	end
	if itemName then
		amountNameString = itemName
	end
	
	if db.powerType and powerType then
		powerString = powerTypes[powerType] .. " "
	else
		powerString = ""
	end
	
	if db.schoolText and school then
		local coloredSchool
		local bracedSchool
		if db.colorSchoolText then
			local color = self:ColorSpellBySchool(school)
			coloredSchool = "|cFF" .. color .. schools[school] .. "|r"
		else
			coloredSchool = schools[school]
		end
		if db.braceSchoolText then
			if db.colorSchoolTextBraces then
				local color = self:ColorSpellBySchool(school)
				bracedSchool = "|cFF" .. color .. db.schoolTextBraceLeft .. "|r" .. coloredSchool .. "|cFF" .. color .. db.schoolTextBraceRight .. "|r"
			else
				bracedSchool = db.schoolTextBraceLeft .. coloredSchool .. db.schoolTextBraceRight
			end
		else
			bracedSchool = coloredSchool
		end
		schoolStr = bracedSchool
	else
		schoolStr = ""
	end
	
	if db.resultString then
		if missType == "RESIST" then
			resisted = amountMissed
		elseif missType == "BLOCK" then
			blocked = amountMissed
		elseif missType == "ABSORB" then
			absorbed = amountMissed
		elseif missType ~= "MISS" then
			resultString = db.format[missType]
		end
			
		if suffix == "_DISPEL_FAILED" then
			resultString = L.failed
		end
		
		if not resultString then resultString = self:DamageResult(resisted, blocked, absorbed, critical, glancing, crushing) end
	end
	
	finalString = (actionString or "") .. srcUnitNameString .. prefixString .. spellNameString .. suffixString .. destUnitNameString .. amountNameString .. powerString .. schoolStr .. resultString
	return finalString
end
